//***************************************************//
//1:           ad9850_reset()                    //
//2:           ad9850_reset_serial()             //
//3:           ad9850_wr_parrel(unsigned char w0,double frequence)//
//4:           ad9850_wr_serial(unsigned char w0,double frequence)//
//汾:              V1.1                            //
//ڣ             2008/12/19                      //
//޸ڣ         2008/12/19                      //
//дߣ         my_dds(my_dds@163.com)            //
//***************************************************//
//                  ӳ˵                       //
//***************************************************//
//1:  ad9850_reset()
//        λad9850֮Ϊдģʽ        
//2:  ad9850_reset_serial()
//        λad9850֮Ϊдģʽ
//3:  ad9850_wr_parrel(unsigned char w0,double frequence)
//        дad9850ݣw0Ϊad9850w0ݣfrequence
//        ΪдƵ	
//4:  ad9850_wr_serial(unsigned char w0,double frequence)
//        дad9850ݣw0Ϊad9850w0ݣfrequence
//        ΪдƵ	
//趨λ
         //ad9850_w_clk    ;
         //ad9850_fq_up    ;
         //ad9850_rest     ;
         //ad9850_bit_data ;
//
         //sbit ad9850_w_clk    =P2^2;
         //sbit ad9850_fq_up    =P2^1;
         //sbit ad9850_rest     =P2^0;
         //sbit ad9850_bit_data =P1^7;
//***************************************************//
//                 д˵                        //
//***************************************************//
//д
//       ad9850_reset()
//       wr_lcd02_data(unsigned char x)
//       ad9850_wr_parrel(0x01,1000)
//       ad9850_wr_serial(0x01,1000)
//***************************************************//
//---------------------------------------------------//
//                                               //
//---------------------------------------------------//
# include <reg51.h>
# include <stdio.h>
# include <intrins.h>
sbit ad9850_w_clk    =P2^2;  //P2.2ڽad9850w_clk/PIN7
sbit ad9850_fq_up    =P2^1;  //P2.1ڽad9850fq_up/PIN8
sbit ad9850_rest     =P2^0;  //P2.0ڽad9850rest/PIN12
sbit ad9850_bit_data =P1^7;  //P1.7ڽad9850D7/PIN25
//P1Ϊ8λݿ
//***************************************************//
//              ad9850λ(ģʽ)                 //
//---------------------------------------------------//
void ad9850_reset()
{
ad9850_w_clk=0;
ad9850_fq_up=0;
//restź
ad9850_rest=0;
ad9850_rest=1;
ad9850_rest=0;
}
//***************************************************//
//              ad9850λ(ģʽ)                 //
//---------------------------------------------------//
void ad9850_reset_serial()
{
ad9850_w_clk=0;
ad9850_fq_up=0;
//restź
ad9850_rest=0;
ad9850_rest=1;
ad9850_rest=0;
//w_clkź
ad9850_w_clk=0;
ad9850_w_clk=1;
ad9850_w_clk=0;
//fq_upź
ad9850_fq_up=0;
ad9850_fq_up=1;
ad9850_fq_up=0;
}
//***************************************************//
//          ad9850д()             //
//---------------------------------------------------//
void ad9850_wr_parrel(unsigned char w0,double frequence)
{
unsigned char w;
long int y;
double x;
//ƵʵHEXֵ
x=4294967295/125;//ʺ125M
//ʱƵʲΪ125MHZ޸ĸôƵֵλMHz 
frequence=frequence/1000000;
frequence=frequence*x;
y=frequence;
//дw0
w=w0;   
P1=w;      //w0
ad9850_w_clk=1;
ad9850_w_clk=0;
//дw1
w=(y>>24);
P1=w;      //w1
ad9850_w_clk=1;
ad9850_w_clk=0;
//дw2
w=(y>>16);
P1=w;      //w2
ad9850_w_clk=1;
ad9850_w_clk=0;
//дw3
w=(y>>8);
P1=w;      //w3
ad9850_w_clk=1;
ad9850_w_clk=0;
//дw4
w=(y>>=0);
P1=w;      //w4
ad9850_w_clk=1;
ad9850_w_clk=0;
//ʼ
ad9850_fq_up=1;
ad9850_fq_up=0;
}
//***************************************************//
//          ad9850д()             //
//---------------------------------------------------//
void ad9850_wr_serial(unsigned char w0,double frequence)
{
unsigned char i,w;
long int y;
double x;
//ƵʵHEXֵ
x=4294967295/125;//ʺ125M
//ʱƵʲΪ180MHZ޸ĸôƵֵλMHz  
frequence=frequence/1000000;
frequence=frequence*x;
y=frequence;
//дw4
w=(y>>=0);
for(i=0;i<8;i++)
{
ad9850_bit_data=(w>>i)&0x01;
ad9850_w_clk=1;
ad9850_w_clk=0;
}
//дw3
w=(y>>8);
for(i=0;i<8;i++)
{
ad9850_bit_data=(w>>i)&0x01;
ad9850_w_clk=1;
ad9850_w_clk=0;
}
//дw2
w=(y>>16);
for(i=0;i<8;i++)
{
ad9850_bit_data=(w>>i)&0x01;
ad9850_w_clk=1;
ad9850_w_clk=0;
}
//дw1
w=(y>>24);
for(i=0;i<8;i++)
{
ad9850_bit_data=(w>>i)&0x01;
ad9850_w_clk=1;
ad9850_w_clk=0;
}
//дw0
w=w0;   
for(i=0;i<8;i++)
{
ad9850_bit_data=(w>>i)&0x01;
ad9850_w_clk=1;
ad9850_w_clk=0;
}
//ʼ
ad9850_fq_up=1;
ad9850_fq_up=0;
}
//***************************************************//
//                   Գ1000Hz                  //
//---------------------------------------------------//
main()
{
P0=0x00;
P1=0x00;
P2=0x00;
P3=0x00;
//---------------------------------------------------//
//д1000Hz
ad9850_reset();
ad9850_wr_parrel(0x00,1000);
//---------------------------------------------------//
while(1)
{
}
}




